# coding: utf-8

"""
    Giphy API

    Giphy API

    The version of the OpenAPI document: 1.0
    Contact: support@giphy.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class User(BaseModel):
    """
    The User Object contains information about the user associated with a GIF and URLs to assets such as that user's avatar image, profile, and more.
    """ # noqa: E501
    avatar_url: Optional[StrictStr] = Field(default=None, description="The URL for this user's avatar image.")
    banner_url: Optional[StrictStr] = Field(default=None, description="The URL for the banner image that appears atop this user's profile page.")
    display_name: Optional[StrictStr] = Field(default=None, description="The display name associated with this user (contains formatting the base username might not).")
    profile_url: Optional[StrictStr] = Field(default=None, description="The URL for this user's profile.")
    twitter: Optional[StrictStr] = Field(default=None, description="The Twitter username associated with this user, if applicable.")
    username: Optional[StrictStr] = Field(default=None, description="The username associated with this user.")
    __properties: ClassVar[List[str]] = ["avatar_url", "banner_url", "display_name", "profile_url", "twitter", "username"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of User from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of User from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "avatar_url": obj.get("avatar_url"),
            "banner_url": obj.get("banner_url"),
            "display_name": obj.get("display_name"),
            "profile_url": obj.get("profile_url"),
            "twitter": obj.get("twitter"),
            "username": obj.get("username")
        })
        return _obj


